// helloworld.cpp : Implementation of CCflake_hello_worldApp and DLL registration.

#include "stdafx.h"
#include "cflake_hello_world.h"
#include "helloworld.h"

/////////////////////////////////////////////////////////////////////////////
//

STDMETHODIMP Chelloworld::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_Ihelloworld,
	};

	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

int Chelloworld::helloworld(char *mystring, char *retmsg)
{
	char tmp[200];

	sprintf(tmp, "hello there %s, how are you today",mystring);

	strcpy(retmsg, tmp);

	return 1;
}


STDMETHODIMP Chelloworld::sayhello(BSTR input, BSTR *output)
{
	char strtmp[200];
	char char_output[200];
	
	// Here we convert the BSTR to a char *
	WideCharToMultiByte(CP_ACP,
		0,
		input,				// actual Message
		lstrlenW(input),	// sizeof bstrMsg
		strtmp,				// recieving variable
		lstrlenW(input),	// sizeof(strMsg),
		NULL,
		NULL);
	
	// Tack on an EOL
	strtmp[lstrlenW(input)] = '\0';		
	
	// here we call the internal COM functions.
	if (helloworld(strtmp, char_output) ) {
		
		// Create a temporary CComBSTR and place the strRetMsg in it.
		CComBSTR bstrTemp(char_output);
		
		// Return the output string
		*output = bstrTemp.Detach();
	}

	return S_OK;
}


